package com.iona.fuse.demo.logisticx.web.customer.client;

/**
 * 
 * Copyright  2007-2008 IONA Technologies PLC.
 *           All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.Command;
import com.google.gwt.user.client.DeferredCommand;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.WindowResizeListener;
import com.google.gwt.user.client.ui.*;

import com.iona.fuse.demo.logisticx.web.customer.client.customer.CustomerView;
import com.iona.fuse.demo.logisticx.web.customer.client.customer.MessageList;
import com.iona.fuse.demo.logisticx.web.customer.client.customer.model.OrderStatus;
import java.util.HashMap;

public class Logisticx implements EntryPoint, WindowResizeListener, TabListener {

    private static Logisticx singleton;
    private static final Images images = (Images)GWT.create(Images.class);

    public interface Images extends CommonImages, TopPanel.Images {
    }

    public static Logisticx get() {
        return singleton;
    }

    //XXXprivate VerticalSplitPanel splitPanel;
    //XXXprivate TopPanel northPanel = new TopPanel(images);
    //private Shortcuts shortcuts = new Shortcuts(images);
    private VerticalPanel centerPanel = new VerticalPanel();
    private MessageList messageList = new MessageList();

    private HashMap views = new HashMap();

    public Panel getContentPanel(){
        return centerPanel;
    }

    public void onModuleLoad() {
        singleton = this;

        TopPanel northPanel = new TopPanel(images);
        northPanel.setWidth("100%");

        //views.put("operations", new OperationsView());
        views.put("customer", new CustomerView());

        centerPanel.add((Composite)views.get("customer"));

        DockPanel dockPanel = new DockPanel();
        dockPanel.add(northPanel, DockPanel.NORTH);
        dockPanel.add(centerPanel, DockPanel.CENTER);

        dockPanel.setWidth("100%");

        dockPanel.setCellWidth(centerPanel, "100%");

        VerticalSplitPanel splitPanel = new VerticalSplitPanel();
        splitPanel.setBottomWidget(messageList);
        splitPanel.setTopWidget(dockPanel);
        splitPanel.setHeight("100%");
        splitPanel.setSplitPosition("80%");

        Window.addWindowResizeListener(this);
        Window.enableScrolling(false);
        Window.setMargin("0px");

        RootPanel.get().add(splitPanel);

        DeferredCommand.addCommand(new Command() {
            public void execute() {
                onWindowResized(Window.getClientWidth(), Window.getClientHeight());
            }
        });
    }


    public void onWindowResized(int width, int height) {
        /*
        int shortcutHeight = height - shortcuts.getAbsoluteTop() - 8;
        if (shortcutHeight < 1) {
            shortcutHeight = 1;
        }
        shortcuts.setHeight("" + shortcutHeight);
        */
    }

    public boolean onBeforeTabSelected(SourcesTabEvents sourcesTabEvents, int i) {
        return true;
    }

    public void onTabSelected(SourcesTabEvents sourcesTabEvents, int i) {
        // Have to resize the gwtMap after everything is positioned so that the size is correct
        onWindowResized(Window.getClientWidth(), Window.getClientHeight()-500);
    }

    public void changeView(String viewName) {
        centerPanel.clear();
        centerPanel.add((Composite)views.get(viewName));
    }

    public void addStatusMessage(OrderStatus message) {
        messageList.addMessage(message);
    }
    
    // Refer to MessageList.receiveOrderStatusMessage(). This method
    // is called to update the message list when the client side receives
    // activemq order status messages.
    public static void updateStatusMessage(String customerPoNumber, String orderId,
        String comments) {
        System.out.println("Update called on client side"); 
        singleton.messageList.updateMessage(customerPoNumber, orderId, comments);
    }
}
