package com.iona.fuse.demo.logisticx.web.customer.client;

/**
 * 
 * Copyright  2007-2008 IONA Technologies PLC.
 *           All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.*;

public class TopPanel extends Composite implements ClickListener, ChangeListener {

  public interface Images extends ImageBundle {
    AbstractImagePrototype logo();
    AbstractImagePrototype logisticx();
  }

  private HTML signOutLink = new HTML("<a href='javascript:;'>Sign Out</a>");
  private HTML aboutLink = new HTML("<a href='javascript:;'>About</a>");

  public TopPanel(Images images) {
    HorizontalPanel outer = new HorizontalPanel();
    VerticalPanel inner = new VerticalPanel();

    outer.setHorizontalAlignment(HorizontalPanel.ALIGN_RIGHT);
    inner.setHorizontalAlignment(HorizontalPanel.ALIGN_RIGHT);

    HorizontalPanel links = new HorizontalPanel();
    ListBox lb = new ListBox();
    lb.addItem("Customer (Create Order)", "customer");
//    lb.addItem("Partner (Manage Resources)", "partner");
//    lb.addItem("Logisticx OperationsView", "operations");
    lb.addChangeListener(this);
    lb.setVisibleItemCount(1);
      
    links.add(new Label("Select demo role: "));
    links.add(lb);
    links.setSpacing(4);
    links.add(signOutLink);
    links.add(aboutLink);

    final Image logo = images.logo().createImage();
    final Image logisticx = images.logisticx().createImage();
    outer.add(logo);
    logisticx.setStyleName( "logisticx-Logo" );
    outer.add(logisticx);
    outer.setCellHorizontalAlignment(logo, HorizontalPanel.ALIGN_LEFT);
    outer.setCellHorizontalAlignment(logisticx, HorizontalPanel.ALIGN_CENTER);

    outer.add(inner);
    inner.add(links);

    signOutLink.addClickListener(this);
    aboutLink.addClickListener(this);

    initWidget(outer);
    setStyleName( "logisticx-TopPanel" );
    links.setStyleName( "logisticx-TopPanelLinks" );
  }

  public void onClick(Widget sender) {
    if (sender == signOutLink) {
      Window.alert("Security not yet implemented.");
    } else if (sender == aboutLink) {
      AboutDialog dlg = new AboutDialog();
      dlg.show();
      dlg.center();
    }
  }

    public void onChange(Widget widget) {
      ListBox listBox = (ListBox) widget;
      Logisticx.get().changeView(listBox.getValue(listBox.getSelectedIndex())); 
    }
}
