package com.iona.fuse.demo.logisticx.web.customer.client.operations;

/**
 * 
 * Copyright  2007-2008 IONA Technologies PLC.
 *           All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.WindowResizeListener;
import com.google.gwt.user.client.ui.*;

import com.iona.fuse.demo.logisticx.web.customer.client.CommonImages;
import com.iona.fuse.demo.logisticx.web.customer.client.TopPanel;

public class OperationsView extends Composite 
    implements WindowResizeListener, TabListener {

    private VerticalPanel rightPanel = new VerticalPanel();
    private GwtMap gwtMap;
    private Shortcuts shortcuts = new Shortcuts(images);
    private DockPanel dockPanel;

    private static final Images images = (Images)GWT.create(Images.class);

    public interface Images extends CommonImages, TopPanel.Images {
    }

    public OperationsView() {

      gwtMap = new GwtMap();
      gwtMap.setWidth("100%");

      TabPanel tp = new TabPanel();
      tp.add(gwtMap, "GwtMap");
      tp.selectTab(2);
      tp.addTabListener(this);

      rightPanel.add(tp);

      dockPanel = new DockPanel();
      dockPanel.add(shortcuts, DockPanel.WEST);
      dockPanel.add(rightPanel, DockPanel.CENTER);

      dockPanel.setWidth("100%");

      dockPanel.setSpacing(4);
      dockPanel.setCellWidth(rightPanel, "100%");

      Window.addWindowResizeListener(this);
      Window.enableScrolling(false);
      Window.setMargin("0px");

      GWT.log("initing widget in OperationView", null);
      initWidget(dockPanel);

      //RootPanel.get().add(dockPanel);

      //DeferredCommand.addCommand(new Command() {
      //    public void execute() {
      //        onWindowResized(Window.getClientWidth(), Window.getClientHeight());
      //    }
      //});
    }

    public Panel getContentPanel(){
        return rightPanel;
    }

    public void onWindowResized(int width, int height) {
        int shortcutHeight = height - shortcuts.getAbsoluteTop() - 8;
        if (shortcutHeight < 1) {
            shortcutHeight = 1;
        }
        shortcuts.setHeight("" + shortcutHeight);

        gwtMap.adjustSize( width, height);
    }

    public boolean onBeforeTabSelected(SourcesTabEvents sourcesTabEvents, int i) {
        return true;
    }

    public void onTabSelected(SourcesTabEvents sourcesTabEvents, int i) {
        // Have to resize the gwtMap after everything is positioned so
        // that the size is correct
        onWindowResized(Window.getClientWidth(), Window.getClientHeight());
    }

}
