package com.iona.fuse.demo.logisticx.web.customer.client.operations;

/**
 * 
 * Copyright  2007-2008 IONA Technologies PLC.
 *           All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DisclosurePanel;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.ScrollPanel;
import com.google.gwt.user.client.ui.VerticalPanel;

public class Vehicles extends Composite
{
    private ScrollPanel panel;
    private VerticalPanel list;

    public Vehicles() {

      VehicleServiceAsync location = ( VehicleServiceAsync ) GWT.create( VehicleService.class);
      ServiceDefTarget endpoint = (ServiceDefTarget) location;
      String moduleRelativeURL = GWT.getModuleBaseURL() + "VehicleService";
      endpoint.setServiceEntryPoint(moduleRelativeURL);

      AsyncCallback callback = new AsyncCallback() {
          Vehicle vehicle = null;
        public void onSuccess(Object result) {
          vehicle = ( Vehicle ) result;
            list.add( addVehicle( vehicle ));
        }

        public void onFailure(Throwable caught) {
          // do some UI stuff to show failure
        }
      };


        panel = new ScrollPanel();
        list = new VerticalPanel();
        panel.setWidget(list);

        for (int i=0; i < 10; i++){
            location.getVehicle(i, callback);
        }

        initWidget(panel);
        setStyleName( "vehicleItem" );
    }

    private DisclosurePanel addVehicle( Vehicle vehicle )
    {
        HTML header = new HTML(vehicle.getName());

        DisclosurePanel item = new DisclosurePanel(header);
        item.add( new HTML("Status: " + vehicle.getStatus() + "<span style='align: right;'><a href='#'>Show GwtMap</a></span><br/>"
                + "Name: " + vehicle.getName() + "<br/>"
                + "Location: " + vehicle.getLocation().getLatitude() + ", "
                + vehicle.getLocation().getLongitude())
        );

        item.getContent().addStyleName("vehicle");

        return item;
    }
}
