package com.iona.fuse.demo.logisticx.service.order.client;

/**
 * 
 * Copyright  2007-2008 IONA Technologies PLC.
 *           All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

import java.util.Calendar;

import com.iona.fuse.demo.logisticx.model.Order;
import com.iona.fuse.demo.logisticx.model.OrderStatus;
import com.iona.fuse.demo.logisticx.model.factory.OrderFactoryBean;
import com.iona.fuse.demo.logisticx.service.order.OrderService;
import org.apache.cxf.interceptor.LoggingInInterceptor;
import org.apache.cxf.interceptor.LoggingOutInterceptor;
import org.apache.cxf.jaxws.JaxWsProxyFactoryBean;

public class cxfOrderClient
{
  public static void main(String[] argv) {

    JaxWsProxyFactoryBean factory = new JaxWsProxyFactoryBean();
    factory.getInInterceptors().add( new LoggingInInterceptor());
    factory.getOutInterceptors().add( new LoggingOutInterceptor());
    factory.setServiceClass( OrderService.class);

    factory.setAddress(argv[0]);
    OrderService client = (OrderService) factory.create();

    OrderFactoryBean orderFactory = new OrderFactoryBean();
    orderFactory.setCustomerId( 1234 );

    Order newOrder = null;
    try
    {
      newOrder = ( Order ) orderFactory.getObject();
    } catch ( Exception e )
    {
      e.printStackTrace(); 
    }

    newOrder.setCustomerPoNumber("testPO#21");
    newOrder.setOrderDate( Calendar.getInstance());

    OrderStatus status = client.putOrder(newOrder);
    System.out.printf( "OrderID is: %s ", status.getOrder().getOrderId() );
   
    newOrder.setOrderId(status.getOrder().getOrderId()); 
    status = client.getOrderStatus(newOrder.getOrderId());
    System.out.printf("Put Order - Status is: %s", status.getStatusCode());
    
    try {
       Thread.sleep(2 * 30 * 1000);
    } catch (Exception ex) {
        //
    }
        
    client = (OrderService) factory.create();
    OrderStatus status2 = client.getOrderStatus(newOrder.getOrderId());
    System.out.printf("Order Processed - Status: %s", status2.getStatusCode());


    
    // Put a Second Order
    orderFactory = new OrderFactoryBean();
    orderFactory.setCustomerId( 123456 );

    Order newOrder2 = null;
    try
    {
      newOrder2 = ( Order ) orderFactory.getObject();
    } catch ( Exception e )
    {
      e.printStackTrace(); 
    }

    newOrder2.setCustomerPoNumber("testPO#2122");
    newOrder2.setOrderDate( Calendar.getInstance());

    status = client.putOrder(newOrder2);
    System.out.printf( "OrderID is: %s ", status.getOrder().getOrderId() );
   
    newOrder2.setOrderId(status.getOrder().getOrderId()); 
    status = client.getOrderStatus(newOrder2.getOrderId());
    System.out.printf("Put Order - Status is: %s", status.getStatusCode());
    
    try {
       Thread.sleep(2 * 30 * 1000);
    } catch (Exception ex) {
        //
    }
        
    client = (OrderService) factory.create();
    status2 = client.getOrderStatus(newOrder2.getOrderId());
    System.out.printf("Order Processed - Status: %s", status2.getStatusCode());

  }
}
