package com.iona.fuse.demo.logisticx.service.order;

/**
 * 
 * Copyright  2007-2008 IONA Technologies PLC.
 *           All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

import javax.jws.WebMethod;
import javax.jws.WebService;

import com.iona.fuse.demo.logisticx.model.OrderStatus;
import com.iona.fuse.demo.logisticx.model.Order;

/**
 * A web service offered to Logisticx customers for handling orders. 
 * 
 * @author bsnyder
 *
 */
@WebService(targetNamespace = "http://logisticx.demo.fuse.iona.com/orderService/")
public interface OrderService {

    /**
     * Used to place an order for the pick up products at the customer site. 
     * 
     * @param order The order object being submitted by the customer
     * @return
     */
    @WebMethod
    public abstract OrderStatus putOrder(Order order);

    /**
     * Used to request the status of any order. 
     * 
     * @param orderId The unique order id for which status is being requested  
     * @return
     */
    @WebMethod
    public abstract OrderStatus getOrderStatus(long orderId);

}
