package com.iona.fuse.demo.logisticx.service.order;

/**
 * 
 * Copyright  2007-2008 IONA Technologies PLC.
 *           All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

import javax.jbi.messaging.DeliveryChannel;
import javax.jbi.servicedesc.ServiceEndpoint;
import javax.jws.WebMethod;
import javax.jws.WebService;

import com.iona.fuse.demo.logisticx.service.order.OrderService;

/**
 * The order web service implementation offered to Logisticx customers. Used to
 * place orders and checking orderStatus.
 *
 */
@WebService(name = "OrderService",
            serviceName = "OrderServiceService",
            portName = "OrderServicePort", 
            targetNamespace = "http://logisticx.demo.fuse.iona.com/orderService/")
public class OrderServiceImpl implements OrderService {
        
    OrderStatus status;
    
    /**
     * Used to submit a single {@link com.iona.fuse.demo.logisticx.model.Order}
     */
    @WebMethod
    public PutOrderResponse putOrder(PutOrder  putorder) {

        Order order = putorder.getOrder();        
        long id = 2333;
        order.setOrderId(id);
        status = new OrderStatus();
        StatusCode code = StatusCode.fromValue("ORDER_PLACED");
        status.setStatusCode(code);                
        status.setOrder(order);
        status.setComments("Thank you for your order!  Your order# is " + order.getOrderId());       
        PutOrderResponse resp = new PutOrderResponse();
        resp.setReturn(status);
        return resp;
    }

    /**
     * Used to check the status of an order.
     */
    @WebMethod
    public OrderStatus getOrderStatus(long orderId) {        
        return status;        
    }

}
